{*****************************************************************************
 *
 *  TileSetter
 *
 *  Copyright (c) 2000, 2001, 2002 Arthur Hoogervorst
 *
 *  Author:     Arthur Hoogervorst
 *  E-mail:     ahooger@istar.ca
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *  2002/22/11  2.2 Removed several commercial components to make it ready for
 *                  GPL.
 *****************************************************************************}
unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ComCtrls, Menus, ExtCtrls, StdCtrls, hyperstr, Clipbrd,
  ImgList, jpeg;


type
  TWordGrid = array of array of integer;
  TResultGrid = array of array of string;
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    PasteSpecial1: TMenuItem;
    Paste1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Index1: TMenuItem;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Seiko: TTimer;
    Saver: TSaveDialog;
    Opener: TOpenDialog;
    Tools1: TMenuItem;
    EditMode1: TMenuItem;
    Panel2: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ResultView: TListView;
    TabSheet4: TTabSheet;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    lblFindResult: TLabel;
    edFindWord: TEdit;
    Button2: TButton;
    Panel3: TPanel;
    rdgFindOptions: TRadioGroup;
    Button1: TButton;
    edRack: TEdit;
    Label1: TLabel;
    Splitter1: TSplitter;
    Panel4: TPanel;
    popResult: TPopupMenu;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    NormalInspect1: TMenuItem;
    Fuzzylogic1: TMenuItem;
    Solve1: TMenuItem;
    N4: TMenuItem;
    Inspectattached1: TMenuItem;
    N1: TMenuItem;
    PastefromYd1: TMenuItem;
    Board: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SeikoTimer(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure EditMode1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ResultViewColumnClick(Sender: TObject; Column: TListColumn);
    procedure ResultViewCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure About1Click(Sender: TObject);
    procedure edRackExit(Sender: TObject);
    procedure edFindWordExit(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure BoardGetEditMask(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure PasteSpecial1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure BoardMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure NormalInspect1Click(Sender: TObject);
    procedure Fuzzylogic1Click(Sender: TObject);
    procedure Inspectattached1Click(Sender: TObject);
    procedure Index1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PastefromYd1Click(Sender: TObject);
    procedure BoardDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);

  private
    { Private declarations }
    PanelString : String;

  public
    WordList : TStringList;
    pWordList : string;
    AppPath : string;
    ColumnSort : integer;
    ColLeftClick : Boolean;
    SavedFile : string;
    GLFLAG : Boolean;
    SelectionColor : TColor;

    procedure FlipColumns(Index : integer);
    procedure SetColumnIcons(index : integer);

    procedure SetCaption(s : string);
    function HTMLFindLetter(s : string) : string;
    function HTMLProcessTD(s : string; openstring,
      closestring : string) : Boolean;
    function HTMLGetTable(s : string) : string;
    function HTMLGetYodaTabel(s : string) : string;
    function GetSelectionString(Arow, ACol, AnEnd,
      direction : integer) : string;
    function getHorizontalWord(xpos, ypos, anend : integer) : string;
    function getVerticalWord(xpos, ypos, anend : integer) : string;

    procedure FindAllLetters(var s : TstringList; alen : integer;
      option : integer);
    function LookUpWordMatch(aword, amatch : string; alen,
      option : integer) : Boolean;
    function LookUpWordPattern(var aword, arack, apattern : string;
      maxlen : integer) : Boolean;
    procedure FindPatternLetters(aword, arack : string;
      var astringlist : TStringList);
    function Points(achar : char) : integer;

    function CountPoints(arow, acol : integer; word : string;
      direction : integer) : integer;

    // New-!
    procedure AddListAttached(atop, aleft : integer; aselection : string;
      AStringList : TStringList; direction : integer);
    procedure AddListItems(AStringList : TStringList; atop, aleft : integer;
      direction : integer; len : integer);
    procedure FindPatternPattern(PatternList : TStringList; aword,
      arack : string; var astringlist : TStringList);
    function FindPatternLetters5(aword, arack : string; index : integer;
      var astringGrid : TResultGrid) : integer;
    procedure AddListItems5(S : TStringList; selection : string;
      r : TGridrect; direction : integer);
    procedure CheckAttached5(r : TGridRect; selectstr, rack : string;
      direction : integer);
    function GetWordAttached(xpos, ypos, direction : integer; var dxpos,
      dypos : integer) : string;
    procedure CheckSelection( r : TGridRect; rack, aword : string;
      direction : integer);
    function GetSelectionWord(r : TGridRect; var direction : integer) : string;
  end;


const
        ENTERS = #13#10;
        JUSTWORDS = #32;
        WORDS = #10#13#32;
        ALEPH : array[0..25] of char =  ('A','B','C','D','E','F','G','H','I',
         'J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y', 'Z');
        LETTERS : array[0..25] of integer = (1,3,3,2,1,4,2,4,1,8,5,
          1,3,1,1,3,10,1,1,1,1,4,4,8,4,10);
        EMPTYBOARD : array[0..5] of string = ('/EMPTY', '/TL', '/DL', '/DW',
          '/TW', '/CENTER');
        Ar : array[0..14, 0..14] of integer =
                       ((4, 0, 0, 1, 0, 0, 0, 4, 0, 0, 0, 1, 0, 0, 4),
                        (0, 2, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 2, 0),
                        (0, 0, 2, 0, 0, 0, 1, 0, 1, 0, 0, 0, 2, 0, 0),
                        (1, 0, 0, 2, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 1),
                        (0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0),
                        (0, 3, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 3, 0),
                        (0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0),
                        (4, 0, 0, 1, 0, 0, 0, 5, 0, 0, 0, 1, 0, 0, 4),
                        (0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0),
                        (0, 3, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 3, 0),
                        (0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0),
                        (1, 0, 0, 2, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 1),
                        (0, 0, 2, 0, 0, 0, 1, 0, 1, 0, 0, 0, 2, 0, 0),
                        (0, 2, 0, 0, 0, 3, 0, 0, 0, 3, 0, 0, 0, 2, 0),
                        (4, 0, 0, 1, 0, 0, 0, 4, 0, 0, 0, 1, 0, 0, 4));
        CREDITS : array[0..14, 0..14] of string =
                (('T','H','E','R','E','','W','E','','A','R','E','','',''),
                 ('','','','','','','','','','','','','','',''),
                 ('','','','','','B','','','','','','','','D',''),
                 ('','','','','','R','','','','','','','','E',''),
                 ('','','','','S','U','S','A','N','','S','A','R','A','H'),
                 ('','','','','','C','','N','','','','','','N',''),
                 ('','G','A','Y','L','E','','G','','','J','O','A','N',''),
                 ('','','R','','','','','E','','','O','','L','A',''),
                 ('','','T','','','','E','L','S','I','E','','F','',''),
                 ('','','H','','','D','','A','','','D','','O','',''),
                 ('','J','U','S','T','I','N','','','','Y','','N','',''),
                 ('','','R','','','A','','','','','','','S','',''),
                 ('','','','H','E','N','K','','','','','','','',''),
                 ('','' ,'','','','N','','','','','','','','',''),
                 ('','','M','I','K','E','','','2','0','0','1','','',''));



var
  Form1: TForm1;

implementation

uses frmAbout;

{$R *.DFM}

procedure TForm1.FlipColumns(Index : integer);
begin
  setColumnIcons(index);
  case Index of
    0 : begin
          ResultView.Columns[1].ImageIndex := -1;
          ResultView.Columns[2].ImageIndex := -1;
      end;
    1 : begin
          ResultView.Columns[0].ImageIndex := -1;
          ResultView.Columns[2].ImageIndex := -1;
        end;
    2 : begin
          ResultView.Columns[0].ImageIndex := -1;
          ResultView.Columns[1].ImageIndex := -1;
        end;
  end;
end;


procedure TForm1.SetColumnIcons(index : integer);
begin
  case resultView.Columns[index].tag of
    1 : begin
          resultView.Columns[index].Tag := 0;
          resultView.Columns[index].ImageIndex := 0;
        end;
    0 : begin
          resultView.Columns[index].Tag := 1;
          resultView.Columns[index].ImageIndex := 1;
        end;
  end;
end;

Procedure TForm1.SetCaption(s : string);
begin
  Form1.Caption := 'TileSetter [' + s + ']'
end;

function TForm1.HTMLFindLetter(s : string) : string;
const src = 'SRC="';
var k : char;
    l, sa : string;
    p, cnt : integer;
begin
  for p := 0 to 5 do
  begin
    if pos(EMPTYBOARD[p], s) > 0 then
    begin
      HTMLFindLetter := '';
      exit;
    end;
  end;

  if s = '' then
  begin
    HTMLFindLetter := '';
    exit;
  end;

  p := pos(src, s);
  p := p + length(src);
  l := Copy(s, p, length(s));
  // find first "
  p := pos('"', l);
  l := Copy(l, 1, p -1);

  p := pos('.', l);
  // jffjj/jfjjfj/kkfkf.gif
  l := Copy(l, 1, p -1);
  cnt := Length(l);
  repeat
     sa := l[cnt];
     dec(cnt);
     k := l[cnt];
  until k = '/';

  HTMLFindLetter := sa;
end;

function TForm1.HTMLProcessTD(s : string; openstring, closestring : string) : Boolean;
var res, let  : string;
    c, cnt, r : integer;
begin
  c := 1; r := 0; cnt := 1;
  res := ParseTag(s, openstring, closestring, cnt);
  repeat
    let := HTMLFIndLetter(res);
    if let <> '' then
    begin
      Board.Cells[c - 1, r] := let;
    end;
    res := ParseTag(s, openstring, closestring, cnt);
    if c mod 15 = 0 then
    begin
      inc(r);
      c := 1
    end
    else
      inc(c);
    Application.ProcessMessages;
  until (res = '');

  if r < 14 then
  begin
    HTMLProcessTD := False
  end
  else
  begin
    HTMLProcessTD := True
  end;
end;

function TForm1.HTMLGetTable(s : string) : string;
var cnt : integer;
    res, ns : string;
begin
  // Function will get the positione-th table tag,
  // extracts the complete table code and returns a string for processing.
  // For the Nuthouse that is table 3 for the *board*...
  res := '';
  cnt := 1;
  ns := uppercase(s);
  res := ParseTag(ns, '<TABLE', '/TABLE>', cnt);
  repeat
    res := ParseTag(ns, '<TABLE', '/TABLE>', cnt);
    Application.ProcessMessages;
  until (pos('TILES/', res) > 0) or (res = '');
  HTMLGetTable := res;
end;

function TForm1.HTMLGetYodaTabel(s : string) : string;
var cnt : integer;
    res, ns : string;
begin
  result := '';
  cnt := 1;
  ns := uppercase(s);
  res := ParseTag(ns, '<TABLE', '/TABLE>', cnt);
  Result := res;
end;


function TForm1.Points(achar : char) : integer;
var x : integer;
begin
  for x := 0 to high(ALEPH) do
  begin
    if ALEPH[x] = achar then
    begin
      Points := LETTERS[x];
      exit
    end;
  end;
  Points := 0;
end;

function TForm1.CountPoints(arow, acol : integer; word : string; direction : integer) : integer;
var x, t, pnts : integer;
    s : string;
begin
  // Use the array for counting letters :)
  // 0 : ===> horizontal
  // 1 : ===> vertical
  // 2 : --->>> NONE!
  s := '';
  pnts := 0;
  t := 1;
  case direction of
  0 : begin
        for x := 1 to length(word) do
        begin
          case Ar[acol + x - 1, arow ] of
          0, 5 : begin
                pnts := pnts + Points(word[x]);
              end;
          1 : begin
                if trim(Board.Cells[acol + x - 1, arow]) = '' then
                begin
                  pnts := pnts + Points(word[x]) * 2;
                end
                else
                begin
                  pnts := pnts + Points(word[x]);
                end;
              end;
          2 : begin
                if trim(Board.Cells[acol + x - 1, arow]) = '' then
                begin
                  t := t * 2;
                  pnts := pnts + Points(word[x]);
                end
                else
                begin
                  pnts := pnts + Points(word[x]);
                end;
              end;
          3 : begin
                if trim(Board.Cells[acol + x - 1, arow]) = '' then
                begin
                  pnts := pnts + Points(word[x]) * 3;
                end
                else
                begin
                  pnts := pnts + Points(word[x]);
                end;

              end;
          4 : begin
                if trim(Board.Cells[acol + x - 1, arow]) = '' then
                begin
                  t := t * 3;
                  pnts := pnts + Points(word[x]);
                end
                else
                begin
                  pnts := pnts + Points(word[x]);
                end;
              end;
          end;
        end
      end;
  1 :begin
       for x := 1 to length(word) do
       begin
          case Ar[acol, arow + x - 1] of
          0, 5 : begin
                pnts := pnts + Points(word[x]);
              end;
          1 : begin
                if trim(Board.Cells[acol, arow + x - 1]) = '' then
                begin
                  pnts := pnts + Points(word[x]) * 2;
                end
                else
                begin
                  pnts := pnts + Points(word[x]);
                end;
              end;
          2 : begin
                if trim(Board.Cells[acol, arow + x - 1]) = '' then
                begin
                  t := t * 2;
                  pnts := pnts + Points(word[x]);
                end
                else
                begin
                  pnts := pnts + Points(word[x]);
                end;
              end;
          3 : begin
                if trim(Board.Cells[acol, arow + x - 1]) = '' then
                begin
                  pnts := pnts + Points(word[x]) * 3;
                end
                else
                begin
                  pnts := pnts + Points(word[x]);
                end;

              end;
          4 : begin
                if trim(Board.Cells[acol, arow + x - 1]) = '' then
                begin
                  t := t * 3;
                  pnts := pnts + Points(word[x]);
                end
                else
                begin
                  pnts := pnts + Points(word[x]);
                end;
              end;
          end;
       end
     end;

  2: begin
       for x := 1 to length(word) do
       begin
         pnts := pnts + Points(word[x]);
       end;
     end;
  end;
  CountPoints := t * pnts;
end;


function TForm1.GetSelectionString(Arow, ACol, AnEnd, direction : integer)
  : string;
begin
  case direction of
  0 : begin
        // horizontal word!
        GetSelectionString := getHorizontalWord(Acol, Arow, AnEnd);
      end;
  1 : begin
        // vertical word!
        GetSelectionString := getVerticalWord(Acol, Arow, AnEnd);
      end
  end;
end;


function TForm1.getHorizontalWord(xpos, ypos, anend : integer) : string;
var  h1, h2, s : string;
    x : integer;
begin
  h1 := '';
  h2 := '';
  s := '';
  x := xpos;
  //s := Trim(Board.Cells[x, ypos]);
  repeat
    s := Trim(Board.Cells[x, ypos]);
    if s = '' then
      // replace blanks with questionmark
      s := '?';
    h1 := s + h1;
    dec(x)
  until (x < xpos);


  x := xpos + 1;
  s := '';
  repeat
     s := Trim(Board.Cells[x, ypos]);
     if s = '' then
       s := '?';
     h2 := h2 + s;
    inc(x);
  until (x > anend);

  getHorizontalWord :=  h1 + h2;
end;

function TForm1.getVerticalWord(xpos, ypos, anend: integer) : string;
var h1, h2, s : string;
    y : integer;
begin
  h1 := '';
  h2 := '';
  s := '';
  y := ypos;
  //s := Trim(Board.Cells[x, ypos]);
  repeat
    s := Trim(Board.Cells[xpos, y]);
    if s = '' then
       s := '?';

    h1 := s + h1;
    dec(y)
  until (y < ypos);


  y := ypos + 1;
  s := '';
  repeat
     s := Trim(Board.Cells[xpos, y]);
     if s = '' then
       s := '?';
     h2 := h2 + s;
    inc(y);
  until (y > anend);
  getVerticalWord :=  h1 + h2;
end;




procedure TForm1.FindAllLetters(var s : TstringList; alen : integer; option : integer);
var start  : integer;
    res, match : string;
    t : string;
begin
  // Base routine...
  // Finds *all* words that can be made out of the Rack Letters.
  // Pretty fast and maybe useful for *JUMBLE* puzzles.
  t := #10#13#32;
  // p := WordList.Text;
  // of course start with word 1.

  start := 1;
  match := edRack.Text;
  res := ParseWord(pWordList, t, start);
  PanelString := 'Searching...';
  Seiko.Enabled := True;
  repeat
    // Just the words in rack
    if LookUpWordMatch(res, match, alen, option) then
    begin
       s.Add(res);
    end;

    res := ParseWord(pWordList, t, start);
    Application.ProcessMessages;
  until (Length(res) = 0);
  Seiko.Enabled := False;
  StatusBar1.Panels[0].Text := '';
end;

function TForm1.LookUpWordMatch(aword, amatch : string; alen,
  option : integer) : Boolean;
var doneChars, cp1, cp2 : string;
    x, counter, blankc : integer;
begin
  // Count the blanks.
  blankc := CountF(amatch, '#', 1);
  case option of
  0, 2, 3, 4
     : begin
        // Search words in letters of the rack
        // we just swap the word with match, so
        // *we* search for a match with any word.

        cp1 := amatch;
        cp2 := aword;
        // A little bit quick and dirty, but passing
        // the options works this way <g>
        case option of
        2 : begin
              // Word < length as defined by user
              if (length(cp2) < alen) then
              begin
                  LookUpWordMatch := False;
                  exit;
              end;
            end;
        3 : begin
              // Word > length
              if (length(cp2) > alen) then
              begin
                  LookUpWordMatch := False;
                  exit;
              end;
            end;
        4 : begin
              // Word not equals length
              if (length(cp2) <> alen) then
              begin
                  LookUpWordMatch := False;
                  exit;
              end;
            end;
        end;
      end;
  1  : begin
        // Search all words with all letters!
        cp1 := aword;
        cp2 := amatch
      end
  end;



  SetLength(doneChars, length(amatch));
  FillStr(doneChars, 1,' ') ;
  // Start LOOP.
  for x := 1 to length(cp2) do
  begin
    // We're looping through a match or word (depending on search
    // routine!): we're going to look if there are any characters[x]
    // in the lookupword (cp1). Also be sure to check for blanks,
    // since blanks may substitute a not found character

    // Nothing found:
    if CountF(cp1, cp2[x], 1) = 0 then
    begin
      if (blankc > 0) then
      begin
        // There is a blank, just subtract the number of blanks
        // with one.
        dec(blankc);
      end
      else
      begin
        // Blank = 0 and No counts, exit,
        // return FALSE (No match)
        LookUpWordMatch := False;
        exit
      end;
    end
    else
    begin
      // Found something.
      // Check how many of the same characters are in the word
      // Check if the character is already put in
      // donechars.
      counter := CountF(doneChars, cp2[x], 1);
      if counter > 0 then
      begin
        // if so, add one to counter.
        inc(counter);
        // now check if we don't have too much of the same character,
        // by comparing the counter with the countF of the word!
        // ex. 'Woodenshoe'  ---- 3 counts....
        if counter > CountF(cp1, cp2[x], 1) then
        begin
          // Apparently too much!
          LookUpWordMatch := False;
          exit;
        end;
      end;
      // put the character in donechar!
      doneChars[x] := cp2[x];
    end;
  end;
  LookUpWordMatch := True;
end;


function TFOrm1.LookUpWordPattern(var aword, arack, apattern : string;
  maxlen : integer) : Boolean;
var x, p, blankc, val : integer;
    orgpat, orgrack, cmp, tot, hashlist: string;
begin
  // check for lenght (change made [AH] - R , was >)
  if length(aword) <> maxlen then
  begin
    LookUpWordPattern := False;
    exit;
  end;

  if isMatch(aword, apattern, False) = False then
  begin
    LookUpWordPattern := False;
    exit
  end;

  { Change made [AH] - R
  if length(apattern) = CountF(apattern, '?', 1) then
  begin
    LookUpWordPattern := False;
    exit;
  end;}

  x := 1;
  cmp := '';
  orgpat := apattern;
  // DeleteC(orgpat, '*');
  val := scanW(aword, apattern, x);
  if val > 0 then
  begin
    // This may be tricky, but there we go again!
    // Rack Letters EMOEEDP
    // P?W?R     found: EMPOWERED
    //                  **X?X?X**
    // extract available letters?
    // x = 3
    // Build up string!/// SHOOOT... Do you get this?? whole code? :)
    p := ScanC(apattern, '?', 1);
    repeat
      cmp := cmp + aword[x + p - 1];
      // make smaller!
      if pos(aword[x + p - 1], arack) = 0 then
        aword[x + p - 1] := Chr(Ord(aword[x + p - 1]) + 32);
      p := ScanC(apattern, '?', p + 1)
    until p = 0;

    tot := Trim(Trim(Copy(aword, 1, x - 1)) + trim(cmp)
      + Trim(copy(aword, x + length(apattern), length(aword))));
    // tot := First + cmp + last;
    // we got a *string* <g>...
    // AW... now we have... [EMOEED]
    // and our rack = [EMOEEDP]
    hashlist := tot;
    orgrack := arack;
    blankc := CountF(orgrack, '#', 1);

    for x := 1 to length(tot) do
    begin
       p := ScanC(orgrack, tot[x], 1);
       if (p > 0) then
       begin
         DeleteS(orgrack, p, 1);
       end
       else
       begin
         // HO, HO!
         if blankc > 0 then
         begin
           dec(blankc);
           //DeleteS(orgRack, p, 1); // Be sure to remove the thingee...
         end
         else
         begin
           LookUpWordPattern := False;
           exit;
         end;
       end;
    end;
    LookUpWordPattern := True;
  end
  else
  begin
    LookUpWordPattern := False;
  end;
end;

procedure TForm1.AddListAttached(atop, aleft : integer; aselection : string;
  AStringList : TStringList; direction : integer);
var x, p, lx, ly : integer;
    ListItem : TListItem;
    k : string;
begin
  // Add the First word...
  ListItem := ResultView.Items.Add;
  ListItem.Caption := Trim(aselection);
  if direction = 0 then
    ListItem.ImageIndex := 3
  else
    ListItem.ImageIndex := 4;
  ListItem.SubItems.Add(IntToStr(CountPoints(atop, aleft, aselection,
    direction)));
  ListItem.SubItems.Add(IntToStr(length(aselection)));


  // Process the stringlist;
  x := 0;

  repeat
    ListItem := ResultView.Items.Add;
    k := Trim(aStringList.Strings[x]);
    ListItem.Caption := k;
    if direction = 0 then
      ListItem.ImageIndex := 4
    else
      ListItem.ImageIndex := 3;

    inc(x);  // We're getting the coordinates

    // WARNING HERE!!!!

    p := pos('|', AstringList.Strings[x]);
    // if 0 --> 1
    // if 1 --> 0

    // abs(0 - 1).1 = 1
    // abs (1-1).

    lx := StrToInt(Copy(AstringList.Strings[x], 1, p -1));
    ly := StrToInt(copy(AstringList.Strings[x], p + 1,
      Length(AstringList.Strings[x])));
    ListItem.SubItems.Add( IntToStr(CountPoints(ly, lx, k,
      abs(direction - 1) * 1)));
    ListItem.SubItems.Add(IntToStr(length(AStringList.Strings[x])));
    Application.ProcessMessages;
    inc(x);
  until (x >= (AStringList.Count - 1));

end;


procedure TForm1.AddListItems(AStringList : TStringList; atop, aleft : integer;
  direction : integer; len : integer);
var x : integer;
    ListItem : TListItem;
begin

  for x := 0 to AStringList.Count -1 do
  begin
    ListItem := ResultView.Items.Add;
    ListItem.Caption := Trim(AStringList.Strings[x]);
    if length(AStringList.Strings[x]) = len then
      ListItem.ImageIndex := 2
    else
      ListItem.ImageIndex := 3;
    ListItem.SubItems.Add(IntToStr(CountPoints(atop, aleft, AStringList[x],
      direction)));
    ListItem.SubItems.Add(IntToStr(length(AStringList.Strings[x])));
    Application.ProcessMessages;
  end;

end;


function TForm1.FindPatternLetters5(aword, arack : string;
  index : integer; var astringGrid : TResultGrid) : integer;
var  rowtext,  rack, res : string;
      start,  cnt : integer;
begin

  rack := trim(arack);
  cnt := 0;
  start := 1;
  rowtext := aword;
  if CountF(aword, '?', 1) > 0 then
  begin
    res := UpperCase(ParseWord(pWordList, WORDS, start));
    repeat
      if LookUpWordPattern(res, rack, rowtext, length(rowtext)) then
      begin
        // Set length of array in array astringgrid
        SetLength(astringGrid[index], cnt + 1);
        astringGrid[index, cnt] := res;
        inc(cnt);
      end;
      res := ParseWord(pWordList, WORDS, start);
      Application.ProcessMessages;
    until (Length(res) = 0);
  end;
  FindPatternLetters5 := cnt;
end;

procedure TForm1.FindPatternPattern(PatternList : TStringList; aword,
  arack : string; var astringlist : TStringList);
var  rowtext,  rack, res, strip : string;
      start : integer;
begin

  rack := trim(arack);

  start := 1;
  rowtext := UpperCase(aword);
  if CountF(aword, '?', 1) > 0 then
  begin
    res := ParseWord(PatternList.text, WORDS, start);
    // CORECTION_AH1 We want to circumvent the 'automatic' conversion
    // to smallercase in LookUpWordMatch
    strip := UpperCase(res);
    repeat
      if LookUpWordPattern(strip, rack, rowtext, length(rowtext)) then
      begin
        // ListBox1.Items.Add(res);
        astringlist.Add(res);
      end;
      res := ParseWord(PatternList.text, WORDS, start);
      // CORECTION_AH1 We want to circumvent the 'automatic' conversion
      // to smallercase in LookUpWordMatch
      strip := UpperCase(res);
      Application.ProcessMessages;
    until (Length(res) = 0);
  end
  else
  begin
    // 02/02/01 There are no ? in pattern, so *whole* word...
    // Look up in S if the word exists in there...
    if PatternList.IndexOf(rowtext) > -1 then
    begin
      // [CORRECTION taken over from TileSettled
      // instead of adding rowtext, add aword:
      // otherwise words might be uppercased.
      astringList.add(aword);
    end;
  end;
end;


procedure TForm1.FindPatternLetters(aword, arack : string;
  var astringlist : TStringList);
var  rowtext,  rack, res : string;
      start : integer;
begin

  rack := trim(arack);

  start := 1;
  rowtext := aword;
  if CountF(aword, '?', 1) > 0 then
  begin
    res := ParseWord(pWordList, WORDS, start);
    repeat
      if LookUpWordPattern(res, rack, rowtext, length(rowtext)) then
      begin
        // ListBox1.Items.Add(res);
        astringlist.Add(res);
      end;
      res := ParseWord(pWordList, WORDS, start);
      Application.ProcessMessages;
    until (Length(res) = 0);
  end;

end;

function TForm1.GetSelectionWord(r : TGridRect;
  var direction : integer) : string;
var xd, yd : integer;
begin
  //
  xd := r.Right - r.Left;
  yd := r.Bottom - r.Top;

  if ((xd = 0) or (yd = 0)) then
  begin
    if (r.Right - r.Left) > 0 then
    begin
      // horizontal == 0
      GetSelectionWord := GetSelectionString(r.top, r.left, r.right, 0);
      direction := 0;
     end
    else
    begin
      // vertical == 1
      GetSelectionWord := GetSelectionString(r.top, r.left, r.bottom, 1);
      direction := 1
    end;
  end;
end;

function TForm1.GetWordAttached(xpos, ypos, direction : integer; var dxpos,
  dypos : integer) : string;
var s1,  s, res : string;
    x, y : integer;
begin
  Res := '';
  // Basically this is the same function as
  // the functions below, but we walk until we find a empty string.
  if direction = 0 then
  begin
    // y := ypos
    s := '?';
    y := ypos -1;
    for y := y downto 0 do
    begin
      s1 := Trim(Board.Cells[xpos, y]);
      if s1 = '' then
      begin
        break;
      end;
      s := s1 + s;
    end;

    // vertical word for horizontal selection:
    // Length can be defined by the 'length of string'!
    dxpos := xpos;
    // [02/Mrch/Correction]... Originally the error came up in
    // the [1] direction branch in this function. Corrected this
    // too (basically, the downto causes the y to be -1 if the
    // loop is completed.
    if (s1 = '')  or (y < 0) then
      dypos := y + 1
    else
      dypos := 0;

//    dypos := y;

    res := s;

    s := '';
    y := ypos + 1;
    for y := y to 14 do
    begin
      s1 := Trim(Board.Cells[xpos, y]);
      if s1 = '' then
      begin
        break;
      end;
      s := s + s1;
    end;
    res := res + s;
  end
  else
  begin
    s := '?';
    x := xpos -1;
    for x := x downto 0 do
    begin
      s1 := Trim(Board.Cells[x, ypos]);
      if s1 = '' then
      begin
        break;
      end;
      s := s1 + s;
    end;


    // vertical word for horizontal selection:
    // Length can be defined by the 'length of string'!
    // [03/mrch/01] OOZE error!
    if (s1 = '') or  (x < 0) then
      dxpos := x + 1
    else
    begin
        dxpos := x;
    end;

    dypos := ypos;

    res := s;

    x := xpos + 1;
    for x := x to 14 do
    begin
      s1 := Trim(Board.Cells[x, ypos]);
      if s1 = '' then
      begin
        break;
      end;
      res := res + s1;
    end;
  end;

  GetWordAttached := Res
end;


procedure TForm1.AddListItems5(S : TStringList; selection : string;
  r : TGridrect; direction : integer);
var x, y, p, lx, ly : integer;
    ListItem : TListItem;
    l : string;
begin

  for x := 0 to S.Count - 1 do
  begin
    // Start with the selection!
    // Selection has imageindex 5, horizontal = 3/vertical = 4...
    ListItem := ResultView.Items.Add;
    ListItem.Caption := Trim(S.Strings[x]);
    ListItem.ImageIndex := direction + 4;

    ListItem.SubItems.Add(IntToStr(CountPoints(r.top, r.left,
      Trim(S.Strings[x]), direction)));
    ListItem.SubItems.Add(IntToStr(length(S.Strings[x])));

    for y := 1 to length(selection) do
    begin
      if selection[y] = '?' then
      begin
        if direction = 0 then
        begin
          l := GetWordAttached(r.left + y -1, r.top, direction, lx, ly);
          if Trim(l) <> '?' then
          begin
            // ReplaceChar...
            l[pos('?', l)] := S.Strings[x][y];
            ListItem := ResultView.Items.Add;
            ListItem.Caption := l;

            ListItem.ImageIndex := 5;
            p := CountPoints(ly, lx, l, abs(direction - 1) * 1);
            ListItem.SubItems.Add(IntToStr(p));
            ListItem.SubItems.Add(IntToStr(length(l)));
          end;
        end
        else
        begin
          l := GetWordAttached(r.left, r.top + y -1, direction, lx, ly);
          if Trim(l) <> '?' then
          begin
            l[pos('?', l)] := S.Strings[x][y];
            ListItem := ResultView.Items.Add;
            ListItem.Caption := l;
            ListItem.ImageIndex := 4;
            p := CountPoints(ly, lx, l, abs(direction - 1) * 1);
            ListItem.SubItems.Add(IntToStr(p));
            ListItem.SubItems.Add(IntToStr(length(l)));
          end;
        end;
      end;
    end;
  end;
end;


procedure TForm1.CheckAttached5(r : TGridRect; selectstr,
  rack : string; direction : integer);
var S,  patternA : TStringList;
    t : TDateTime;
    h, m, sk, ms : Word;
    x , px, cx, cy, idx, numb, tc, tackle : integer;
    l, tl, nrack, npattern : string;
    arw : array of string;
    apx : TWordGrid;
    arx : TResultGrid;
    AFlag : Boolean;
begin
  ResultView.Items.Clear;
  AFlag := True;
  nrack := rack;

  S := TStringList.Create;
  PanelString := 'Checking...';
  Seiko.Enabled := True;
  t := now;

  StatusBar1.Panels[2].text := 'Checking combinations...';
  // [06/04/01] get all existing combinations.
  FindPatternLetters(selectstr, rack, S);
  if S.Count = 0 then
  begin
    AFlag := False;
    StatusBar1.Panels[2].text := 'No combinations found...';
  end;
  // [TODO - check if empty!]
  // [06/04/01] There are combinations, we're now
  // going to create arrays with information about
  // the attached words.
  if AFlag then
  begin
    PatternA := TStringList.Create;
    PanelString := 'Checking...';
    StatusBar1.Panels[2].text := 'Lookup... attached words';
    // Check the attached words...
    px := 1;
    idx := 1;
    px := ScanC(selectstr, '?', px);
    // [06/04/01] There are two directions. Horizontal + vertical. Funny enough,
    // I recall that a horizontal direction meant looking for 'vertical attached
    // words'. Am not sure if 0 = horizontal or vertical :-)
    repeat
      if direction = 0 then
      begin
        l := GetWordAttached(r.left + px -1, r.top, direction, cx, cy);
      end
      else
      begin
        l := GetWordAttached(r.left, r.top + px -1, direction, cx, cy);
      end;
      // [06/04/01] the found attached word is stored in L, and is ready
      // for the 'array processing'. This part is also similar to
      // the TileSettleD project, but instead of arrays I used variant arrays
      if Trim(l) <> '?' then
      begin
        // [06/04/01] Redim Array that stores the word only.
        SetLength(arw, idx);
        // 0 = String
        arw[idx - 1] := l;
        // [06/04/01] Redim array that stores critical information on the word
        SetLength(apx, idx);
        SetLength(apx[idx -1], 4);
        apx[idx -1, 0] := px;  // [06/04/01] Position of 'questionmark'? (not sure)
        apx[idx -1, 1] := direction; // [06/04/01] direction
        apx[idx -1, 2] := cx; // [06/04/01] Position on board
        apx[idx -1, 3] := cy; // [06/04/01] Position on board
        inc(idx);
      end;
      inc(px);
      px := ScanC(selectstr, '?', px);
      Application.ProcessMessages;
    until px = 0;
    // [06/04/01] We're refining now. We first check if the APX array was filled
    // indeed.
    if High(apx) > -1 then
    begin
      StatusBar1.Panels[2].text := 'Refining...';
      // [06/04/01] We're now going to loop through the found attached words!
      // Found matches are stored in the arx array?
      for x := Low(arw) to High(arw) do
      begin
        // Use of Length = OK too
        SetLength(arx, High(arw) + 1);
        // [06/04/01] arx is resized in the following function!
        numb := FindPatternLetters5(arw[x], rack, x, arx);
        if numb = 0 then
        begin
          // This word doesn't have matches, so quit nicely...
          // [06/04/01] The good thing about the attached word routine is the
          // fact that if there are no matches for the word, the whole routine
          // can be stopped. Or something :-)
          StatusBar1.Panels[2].text := 'Empty!';
          AFlag := False;
          break;
        end
      end
    end
    else
    begin
     AFlag := False;
     StatusBar1.Panels[2].Text := 'No attached words...';
    end;
  end;
  // Arrays---> ready.
  // Selection results ready...
  // Here we go....
  // Get the following --- TENT? .... TENTS .... TENTH ... TENTY
  //                       S?          SI ......  SO
  //                       PI?         PIC ... PIT ... PIL ... PIP ... PIH
  // Combinations      --- SIC, SIT, SIL, SIP, SIH
  //                   --- SOC, SOT, SOL, SOP, SOH
  //                   --- HIC, HIT, HIL, HIP, HIH
  //                   --- HOC, HOT, HOL, HOP, HOH
  //                   --- YIC, YIT, YIL, YIP, YOH
  //                   --- YOC, YOT, YOL, YOP, YOH   ==== > 30 combinaties....
  //   (3 * 3) + (3 * 2) + (3 * 5) ===
  //      9        6        15    ====  ****30****
  //
  //   Loop door eerste string van array
  //      Get the character1
  //      replace in position apx[0] in selectstr
  //
  //      loop door rest van array + 1
  //        get the character in position px
  //
  // Loop through the first string

  // IDX still has the total of ***found attached words ****

  //  [06/04/01] Arrays are filled, now we're tickling the data.
  if AFlag then
  begin
    npattern := selectstr;
    tackle := 0;
    StatusBar1.Panels[2].text := 'Tickling... ';
    while tackle <= High(arx) do
    begin
      tc := 0;
      while (tc <= High(arx[tackle])) do
      begin
        tl := arx[tackle, tc];  // Base Permuting String
        npattern[apx[tackle,0]] := tl[pos('?', arw[tackle])];
        FindPatternPattern(S, npattern, nrack, patternA);
        inc(tc);
      end;

      S.Assign(patternA);
      patternA.Clear;
      npattern := selectstr;
      Application.ProcessMessages;
      inc(tackle)
    end;

    if S.Count > 0 then
    begin
      AddListItems5(S, selectstr, r, direction);
    end;
    StatusBar1.Panels[2].text := 'Found: ' + IntToStr(S.Count) + ' words ...';
  end;


  t := Now - t;
  DecodeTime(t, h, m, sk, ms);
  StatusBar1.Panels[3].text := IntToStr(sk) + ' (s) ' +
                               IntToStr(ms) + ' (ms)';
  Seiko.Enabled := False;
  StatusBar1.Panels[0].Text := '';

  arw := nil;
  apx := nil;
  arx := nil;
  PatternA.Free;
  S.Free;
end;

procedure TForm1.CheckSelection( r : TGridRect; rack, aword : string;
  direction : integer);
var S : TStringList;
    t : TDateTime;
    h, m, sk, ms : Word;
begin
  ResultView.Items.Clear;
  S := TStringList.Create;

  PanelString := 'Inspecting...';
  Seiko.Enabled := True;
  t := now;

  StatusBar1.Panels[2].Text := 'Start pattern matching...';
  FindPatternLetters(aword, rack, S);
  StatusBar1.Panels[2].Text := 'Finished: ' + IntToStr(S.Count) + ' found...';
  AddListItems(S, r.top, r.left, direction, 0);


  //  lstWords.Items.Assign(S);
  t := Now - t;
  DecodeTime(t, h, m, sk, ms);
  StatusBar1.Panels[3].text := IntToStr(sk) + ' (s) ' +
                               IntToStr(ms) + ' (ms)';
  S.Free;
  Seiko.Enabled := False;
  StatusBar1.Panels[0].Text := '';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  WordList := TStringList.Create;
  AppPath := ExtractFilePath(Application.ExeName);
  WordList.LoadFromFile(AppPath + 'twx.txt');
  pWordList := WordList.Text;
  SavedFile := '';
  SetCaption('untitled');
  SelectionColor := clHighLight;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ResultView.Items.Clear;
  if Seiko.Enabled then
    Seiko.Enabled := False;
  Action := caFree;
end;

procedure TForm1.SeikoTimer(Sender: TObject);
begin
  if Seiko.Tag = 0 then
  begin
    StatusBar1.Panels[0].Text := PanelString;
    Seiko.Tag := 1;
  end
  else
  begin
    StatusBar1.Panels[0].Text := '';
    Seiko.Tag := 0;
  end;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
var x : integer;
    st : TStringList;
begin
  Saver.InitialDir := AppPath;
  if Saver.Execute then
  begin
    st := TStringList.Create;
    for x := 0 to Board.RowCount - 1 do
    begin
      st.Add(Board.Rows[x].CommaText);
    end;
    SetCaption(Saver.Filename);
    SavedFile := Saver.Filename;
    st.SaveToFile(Saver.FileName);
    st.Free;
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
var st : TStringList;
    x : integer;
begin
  Opener.InitialDir := AppPath;
  if Opener.Execute then
  begin
    st := TStringList.Create;
    st.LoadFromFile(Opener.FileName);
    for x := 0 to Board.RowCount -1 do
    begin
      Board.Rows[x].CommaText := st.Strings[x];
    end;
    SetCaption(Opener.Filename);
    SavedFile := Opener.Filename;
    st.free;
  end;
end;


procedure TForm1.New1Click(Sender: TObject);
var x : integer;
begin
  GLFLAG := False;
  for x := 0 to Board.RowCount - 1 do
    Board.Rows[x].Clear;
  SavedFile := '';
  SetCaption('untitled');
end;



procedure TForm1.EditMode1Click(Sender: TObject);
begin
  if goEditing in Board.Options then
  begin
    EditMode1.Checked := False;
    Board.Options := Board.Options - [goEditing];
//    Board.SelectionColor := clRed;
    SelectionColor := clRed;
    StatusBar1.panels[1].text := 'INSPECT';
  end
  else
  begin
    EditMode1.Checked := True;
    Board.Options := Board.Options + [goEditing];
//    Board.SelectionColor := clHighLight;
    SelectionColor := clBlue;
    StatusBar1.panels[1].text := 'EDIT';
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
var Ss : TStringList;
    t : TDateTime;
    h, m, s, ms : word;
begin
  // AH01 -- Version 1.0
  if Trim(edRack.Text) <> '' then
  begin
    ResultView.Items.Clear;
    Button1.Enabled := False;
    Ss := TStringList.Create;
    t := Now;
    FindAllLetters(Ss, 12, rdgFindOptions.ItemIndex);
    if (Ss.Count > 0) then
    begin
      AddListItems(Ss, 0, 0, 2, length(edRack.text));
    end;
    StatusBar1.Panels[2].text := 'Found: ' + IntToStr(Ss.Count) + ' words...';
    t := Now - t;
    DecodeTime(t, h, m, s, ms);
    StatusBar1.Panels[3].text := IntToStr(s) + ' (s) ' +
                                 IntToStr(ms) + ' (ms)';

    Ss.Free;
    Button1.Enabled := True;
  end;
end;

procedure TForm1.ResultViewColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  if (ResultView.Items.Count > 0) then
  begin

    if ResultView.Items.Item[0].ImageIndex >= 4 then
    begin
      exit;
    end;
    ColumnSort := Column.Index;
    FlipColumns(ColumnSort);
    ColLeftClick := True;
    ResultView.SortType := stData;
    // check if first row has a item index >= 3
    (Sender as TCustomListView).AlphaSort
  end;
end;

procedure TForm1.ResultViewCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
var ind : integer;
begin

  Case ResultView.Columns[ColumnSort].Tag  of
  0 : begin
            if ColumnSort = 0 then
            begin
              Compare := CompareText(Item1.Caption,Item2.Caption)

            end
            else
            if (ColumnSort = 1) or (ColumnSort = 2) then
            begin
              ind := ColumnSort - 1;
              if StrToInt(Item1.SubItems[ind]) =
                StrToInt(Item2.SubItems[ind]) then
                Compare := 0
              else
              begin
                if StrToInt(Item1.SubItems[ind]) <
                  StrToInt(Item2.SubItems[ind]) then
                  Compare := -1
                else
                  Compare := 1;
              end;
            end;
        end;
  1 : begin
            if ColumnSort = 0 then
            begin
              ind := CompareText(Item1.Caption,Item2.Caption);
              if ind > 0 then
                Compare := -1
              else
                if ind < 0 then
                  Compare := 1
                else
                  compare := 0

            end;
            if (ColumnSort = 1) or (ColumnSort = 2) then
            begin
              ind := ColumnSort - 1;
              if StrToInt(Item1.SubItems[ind]) =
                 StrToInt(Item2.SubItems[ind]) then
                Compare := 0
              else
              begin
                if StrToInt(Item1.SubItems[ind]) >
                   StrToInt(Item2.SubItems[ind]) then
                  Compare := -1
                else
                  Compare := 1;
              end;
            end;

          end;
   end;
end;


procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.edRackExit(Sender: TObject);
begin
  edRack.Text := Uppercase(edRack.Text)
end;

procedure TForm1.edFindWordExit(Sender: TObject);
begin
  edFindWord.Text := UpperCase(edFindWord.Text)
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Trim(edFindWord.Text) <> '' then
  begin
    PanelString := 'Lookup...';
    Seiko.Enabled := True;
    if WordList.IndexOf(Uppercase(edFindWord.Text)) > 0 then
    begin
      lblFindResult.Caption := 'Word found!'
    end
    else
    begin
      lblFindResult.Caption := 'Word not found!'
    end;
    PanelString := '';
    Seiko.Enabled := False;
  end
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.BoardGetEditMask(Sender: TObject; ACol, ARow: Integer;
  var Value: String);
begin
  Value := '>L<';
end;

procedure TForm1.Cut1Click(Sender: TObject);
begin
  if ActiveControl is TCustomEdit then
  begin
    (ActiveControl as TCustomEdit).CutToClipBoard;
  end;
end;


procedure TForm1.Copy1Click(Sender: TObject);
begin
 if ActiveControl is TCustomEdit then
  begin
    (ActiveControl as TCustomEdit).CopyToClipBoard;
  end;
end;

procedure TForm1.Paste1Click(Sender: TObject);
begin
 if ActiveControl is TCustomEdit then
  begin
    (ActiveControl as TCustomEdit).PasteFromClipBoard;
  end;
end;

procedure TForm1.PastefromYd1Click(Sender: TObject);
var s, l : string;
begin
  if Clipboard.HasFormat(CF_TEXT) then
  begin
    s := ClipBoard.AsText;
    Form1.New1Click(Self);
  end
  else
  begin
    MessageDlg('There is no text on the Clipboard', mtInformation,
          [mbOK],0);
    exit;
  end;
  l := HTMLGetYodaTabel(s);
  if HTMLProcessTD(l, '<IMG', '>') then
  begin
     Application.MessageBox('Board was succesfully imported.' +
       ' Go get them, Tiger!', 'TileSetter',MB_ICONINFORMATION + MB_OK);
  end
  else
  begin
     if HTMLProcessTD(l, '<INPUT', '>') then
     begin
       Application.MessageBox('Board was succesfully imported. Hack-em in'
         + 'letters!', 'TileSetter',MB_ICONINFORMATION + MB_OK);
     end
     else
      Application.MessageBox('Board couldn''t be imported: incompatible' +
        'web pages...', 'TileSetter', MB_ICONINFORMATION + MB_OK);
  end;
end;

procedure TForm1.PasteSpecial1Click(Sender: TObject);
var
     s, l : string;

begin

  if Clipboard.HasFormat(CF_TEXT) then
  begin
    s := ClipBoard.AsText;
    Form1.New1Click(Self);
  end
  else
  begin
    MessageDlg('There is no text on the Clipboard', mtInformation,
          [mbOK],0);
    exit;
  end;


  l := HTMLGetTable(s);

  if l = '' then
  begin
    beep;
    exit
  end;

  // Continue
  if HTMLProcessTD(l, '<INPUT', '>') then
  begin
    Application.MessageBox('Board was imported', 'TileSetter',
      MB_ICONINFORMATION + MB_OK);
  end
  else
  begin
    if HTMLProcessTD(l, '<IMG', '>') then
    begin
       Application.MessageBox('Board was succesfully imported.' +
       'Go get them, Tiger!', 'TileSetter',MB_ICONINFORMATION + MB_OK);
    end
    else
    begin
      Application.MessageBox('Board couldn''t be imported: incompatible' +
       'web pages...', 'TileSetter', MB_ICONINFORMATION + MB_OK);
    end;
  end;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  if SavedFile <> '' then
  begin
    //Board.SaveToCSV(Saver.Filename);
  end;
end;

procedure TForm1.BoardMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (button = mbRight) and (EditMode1.Checked = False )then
  begin
    // Check if we're in InspectMode
    PopUpMenu1.Popup(Board.ClientOrigin.x + x, Board.ClientOrigin.y + y)
  end;
end;

procedure TForm1.NormalInspect1Click(Sender: TObject);
var direction : integer;
    selectstr : string;
begin
  if NormalInspect1.Enabled then
  begin
    NormalInspect1.Enabled := False;
    FuzzyLogic1.Enabled := False;
    InspectAttached1.Enabled := False;
    selectstr := GetSelectionWord(Board.Selection, direction);
    if (Trim(selectstr) <> '') and (Trim(edRack.text) <> '') then
    begin
      CheckSelection(Board.Selection, edRack.text, selectstr, direction);
    end
    else
    begin
      Application.MessageBox(Pchar('Please select a range in one row or column,'
        + 'or fill in your Rack letters'),
        Pchar('TileSetter'), MB_ICONEXCLAMATION);
    end;
    NormalInspect1.Enabled := True;
    FuzzyLogic1.Enabled := True;
    InspectAttached1.Enabled := True;
  end
end;


procedure TForm1.Fuzzylogic1Click(Sender: TObject);
var direction, cnt : integer;
    selectstr : string;

begin
  if FuzzyLogic1.Enabled then
  begin
    FuzzyLogic1.Enabled := False;
    NormalInspect1.Enabled := False;
    InspectAttached1.Enabled := False;
    selectstr := GetSelectionWord(Board.Selection, direction);
    cnt := CountF(selectstr, '?', 1);
    if (cnt > 6) or (cnt = length(selectstr))  then
    begin
      Application.MessageBox(PChar('Functionality defunct at' +
        'function address P > 3001:09A.'#13#10'Message: Com''on'+
        'give me a break huh? Try a dictionary will you? Please? Outta here!'),
        PChar('TileSetter'), MB_ICONINFORMATION);
    end
    else
    begin
       if Trim(edRack.Text) <> '' then
       begin
         CheckSelection(Board.Selection, '########', selectstr, direction);
       end;
    end;
    FuzzyLogic1.Enabled := True;
    NormalInspect1.Enabled := True;
    InspectAttached1.Enabled := True;
  end;
end;

procedure TForm1.Inspectattached1Click(Sender: TObject);
var selectstr : string;
    direction, x, y, x1, p : integer;
    SG : TGridRect;
begin
  if InspectAttached1.Enabled then
  begin
    FuzzyLogic1.Enabled := False;
    NormalInspect1.Enabled := False;
    InspectAttached1.Enabled := False;
    selectstr := GetSelectionWord(Board.Selection, direction);
    // cnt := CountF(selectstr, '?', 1);
    //  if cnt = length(selectstr) then
    //  begin
    //    We can start to check the attached words...
    //    CheckAttached(Board.Selection, Uppercase(edRack.text)
    if (trim(selectstr) <> '') and (Trim(edRack.text) <> '') then
    begin
      if selectstr = 'THANKYOUS' then
      begin
        for x := 0 to Board.RowCount - 1 do
          Board.Rows[x].Clear;

        SG.Left := 0; SG.Right := 0; SG.Top :=0; SG.Bottom := 0;
        Board.Selection := SG;
        StatusBar1.Panels[2].Text := 'File|New = Stop Credits';
        GLFLAG := True;
        Randomize;

        x1 := 1;
        repeat
          x := Random(15);
          y := Random(15);
          if CREDITS[x, y] <> '' then
          begin
            p := GetTickCount + 25;
            if Board.Cells[y, x] = '' then
            begin
              Board.Cells[y, x] := CREDITS[x, y];
              inc(x1);
            end;
            while GetTickCount + 1 < p do
          end;
          Application.ProcessMessages;
        until x1 = 79;

        Randomize;
        x1 := 1;
        repeat
          x := Random(15);
          y := Random(15);
          if Board.Cells[y, x] <> '' then
          begin
            Board.Cells[y, x] := '';
            inc(x1);
          end;
          p := GetTickCount + 4;
          while GetTickCount + 1 < p do
          Application.ProcessMessages;
        until (x1 = 79);


      end
      else
        CheckAttached5(Board.Selection, selectstr, UpperCase(edRack.text),
          direction);
    end
    else
    begin
      Application.MessageBox(Pchar('Please select a range in one row or column'+
       ', or fill in the Rack!'), Pchar('TileSetter'), MB_ICONEXCLAMATION);
    end;
    FuzzyLogic1.Enabled := True;
    NormalInspect1.Enabled := True;
    InspectAttached1.Enabled := True;
  end;
  /// end;
 // Board.rows
end;

procedure TForm1.Index1Click(Sender: TObject);
var res : Boolean;
begin
  res := Application.HelpJump('ID_0003');
  if res = False then
  begin
    Application.Messagebox(Pchar('Help file not found!'), PChar('TileSetter'),
      MB_ICONEXCLAMATION);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WordList.free;
end;



procedure TForm1.BoardDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var r : integer;
    s : string;
    function CenterX(a : TRect; ACanvas : TCanvas; s : string) : integer;
    begin
      result := ((a.Left + a.Right) - ACanvas.TextWidth(s)) div 2
    end;

    function CenterY(a : TRect; ACanvas : TCanvas; s : string) : integer;
    begin
      result := ((rect.Top + rect.Bottom) - ACanvas.TextHeight(s)) div 2
    end;
begin
  s := (Sender as TStringGrid).Cells[Acol,Arow];
  (Sender as TStringGrid).Canvas.Font.Style := [fsBold];
  if gdSelected in State then
  begin
    (Sender as TStringGrid).Canvas.brush.Color := SelectionColor
  end
  else
  begin
    r := ar[Arow, Acol];
    case r of
      0 :  (Sender as TStringGrid).Canvas.brush.Color :=  clYellow;
      1 :  (Sender as TStringGrid).Canvas.brush.Color :=  clAqua;
      2 :  (Sender as TStringGrid).Canvas.brush.Color :=  $00FFA7F9;
      3 :  (Sender as TStringGrid).Canvas.brush.Color :=  clBlue;
      4 :  (Sender as TStringGrid).Canvas.brush.Color :=  clRed;
      5 :  (Sender as TStringGrid).Canvas.brush.Color := clFuchsia
    end;
  end;
 (Sender as TStringGrid).Canvas.TextRect(Rect,
    CenterX(Rect, (Sender as TStringGrid).Canvas, s),
    CenterY(Rect, (Sender as TStringGrid).Canvas, s), s)
end;

end.

